SoNodeKitListPart Class Reference

| http://www.sim.no/ http://www.coin3d.org/

- Main Page
- Related Pages
- Modules
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Static Protected Member Functions | Protected Attributes | List of all members
SoNodeKitListPart Class Reference
NodeKit Classes

The SoNodeKitListPart class is a container node.This node is basically just a container node with these differences versus the other group nodes: More...

`#include <Inventor/nodekits/SoNodeKitListPart.h>`

Inheritance diagram for SoNodeKitListPart:

## Public Member Functions
virtual SoType | getTypeId (void) const
| SoNodeKitListPart (void)
SoType | getContainerType (void) const
void | setContainerType (SoType newContainerType)
const SoTypeList & | getChildTypes (void) const
void | addChildType (SoType typeToAdd)
SbBool | isTypePermitted (SoType typeToCheck) const
SbBool | isChildPermitted (const SoNode *child) const
void | containerSet (const char *fieldDataString)
void | lockTypes (void)
SbBool | isTypeLocked (void) const
void | addChild (SoNode *child)
void | insertChild (SoNode *child, int childIndex)
SoNode * | getChild (int index) const
int | findChild (SoNode *child) const
int | getNumChildren (void) const
void | removeChild (int index)
void | removeChild (SoNode *child)
void | replaceChild (int index, SoNode *newChild)
void | replaceChild (SoNode *oldChild, SoNode *newChild)
virtual SbBool | affectsState (void) const
virtual void | doAction (SoAction *action)
virtual void | callback (SoCallbackAction *action)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | getBoundingBox (SoGetBoundingBoxAction *action)
virtual void | getMatrix (SoGetMatrixAction *action)
virtual void | handleEvent (SoHandleEventAction *action)
virtual void | pick (SoPickAction *action)
virtual void | search (SoSearchAction *action)
virtual void | getPrimitiveCount (SoGetPrimitiveCountAction *action)
virtual SoChildList * | getChildren (void) const
Public Member Functions inherited from SoNode
void | setOverride (const SbBool state)
SbBool | isOverride (void) const
void | setNodeType (const NodeType type)
NodeType | getNodeType (void) const
virtual SoNode * | copy (SbBool copyconnections=FALSE) const
virtual void | GLRenderBelowPath (SoGLRenderAction *action)
virtual void | GLRenderInPath (SoGLRenderAction *action)
virtual void | GLRenderOffPath (SoGLRenderAction *action)
virtual void | rayPick (SoRayPickAction *action)
virtual void | write (SoWriteAction *action)
virtual void | audioRender (SoAudioRenderAction *action)
virtual void | grabEventsSetup (void)
virtual void | grabEventsCleanup (void)
virtual void | startNotify (void)
virtual void | notify (SoNotList *l)
uint32_t | getNodeId (void) const
virtual void | writeInstance (SoOutput *out)
virtual SoNode * | addToCopyDict (void) const
virtual SoFieldContainer * | copyThroughConnection (void) const
Public Member Functions inherited from SoFieldContainer
void | setToDefaults (void)
SbBool | hasDefaultValues (void) const
SbBool | fieldsAreEqual (const SoFieldContainer *container) const
void | copyFieldValues (const SoFieldContainer *container, SbBool copyconnections=FALSE)
SbBool | set (const char *const fielddata)
void | get (SbString &fielddata)
virtual int | getFields (SoFieldList &l) const
virtual int | getAllFields (SoFieldList &l) const
virtual SoField * | getField (const SbName &name) const
virtual SoField * | getEventIn (const SbName &name) const
virtual SoField * | getEventOut (const SbName &name) const
SbBool | getFieldName (const SoField *const field, SbName &name) const
SbBool | enableNotify (const SbBool flag)
SbBool | isNotifyEnabled (void) const
SbBool | set (const char *fielddata, SoInput *input)
void | get (SbString &fielddata, SoOutput *out)
virtual SbBool | validateNewFieldValue (SoField *field, void *newval)
virtual void | addWriteReference (SoOutput *out, SbBool isfromfield=FALSE)
SbBool | getIsBuiltIn (void) const
virtual void | getFieldsMemorySize (size_t &managed, size_t &unmanaged) const
void | setUserData (void *userdata) const
void * | getUserData (void) const
Public Member Functions inherited from SoBase
void | ref (void) const
void | unref (void) const
void | unrefNoDelete (void) const
int32_t | getRefCount (void) const
void | touch (void)
SbBool | isOfType (SoType type) const
virtual SbName | getName (void) const
virtual void | setName (const SbName &newname)
void | addAuditor (void *const auditor, const SoNotRec::Type type)
void | removeAuditor (void *const auditor, const SoNotRec::Type type)
const SoAuditorList & | getAuditors (void) const
SbBool | shouldWrite (void)
void | assertAlive (void) const

## Static Public Member Functions
static SoType | getClassTypeId (void)
static void | initClass (void)
Static Public Member Functions inherited from SoNode
static uint32_t | getCompatibilityTypes (const SoType &nodetype)
static SoType | getClassTypeId (void)
static SoNode * | getByName (const SbName &name)
static int | getByName (const SbName &name, SoNodeList &l)
static void | initClass (void)
static void | initClasses (void)
static uint32_t | getNextNodeId (void)
static int | getActionMethodIndex (const SoType type)
static void | getBoundingBoxS (SoAction *action, SoNode *node)
static void | GLRenderS (SoAction *action, SoNode *node)
static void | callbackS (SoAction *action, SoNode *node)
static void | getMatrixS (SoAction *action, SoNode *node)
static void | handleEventS (SoAction *action, SoNode *node)
static void | pickS (SoAction *action, SoNode *node)
static void | rayPickS (SoAction *action, SoNode *node)
static void | searchS (SoAction *action, SoNode *node)
static void | writeS (SoAction *action, SoNode *node)
static void | audioRenderS (SoAction *action, SoNode *node)
static void | getPrimitiveCountS (SoAction *action, SoNode *node)
Static Public Member Functions inherited from SoFieldContainer
static void | initClass (void)
static SoType | getClassTypeId (void)
static void | cleanupClass (void)
static void | initCopyDict (void)
static void | addCopy (const SoFieldContainer *orig, const SoFieldContainer *copy)
static SoFieldContainer * | checkCopy (const SoFieldContainer *orig)
static SoFieldContainer * | findCopy (const SoFieldContainer *orig, const SbBool copyconnections)
static void | copyDone (void)
Static Public Member Functions inherited from SoBase
static void | initClass (void)
static SoType | getClassTypeId (void)
static void | addName (SoBase *const base, const char *const name)
static void | removeName (SoBase *const base, const char *const name)
static void | incrementCurrentWriteCounter (void)
static void | decrementCurrentWriteCounter (void)
static SoBase * | getNamedBase (const SbName &name, SoType type)
static int | getNamedBases (const SbName &name, SoBaseList &baselist, SoType type)
static SbBool | read (SoInput *input, SoBase *&base, SoType expectedtype)
static void | setInstancePrefix (const SbString &c)
static void | setTraceRefs (SbBool trace)
static SbBool | getTraceRefs (void)
static SbBool | connectRoute (SoInput *input, const SbName &fromnodename, const SbName &fromfieldname, const SbName &tonodename, const SbName &tofieldname)
static SbBool | readRoute (SoInput *input)

## Protected Member Functions
virtual const SoFieldData * | getFieldData (void) const
virtual | ~SoNodeKitListPart ()
SoGroup * | getContainerNode (void)
virtual SbBool | readInstance (SoInput *in, unsigned short flags)
virtual void | copyContents (const SoFieldContainer *fromFC, SbBool copyConnections)
Protected Member Functions inherited from SoNode
| SoNode (void)
virtual | ~SoNode ()
Protected Member Functions inherited from SoFieldContainer
| SoFieldContainer (void)
virtual | ~SoFieldContainer ()
Protected Member Functions inherited from SoBase
| SoBase (void)
virtual | ~SoBase ()
virtual void | destroy (void)
SbBool | hasMultipleWriteRefs (void) const
SbBool | writeHeader (SoOutput *out, SbBool isgroup, SbBool isengine) const
void | writeFooter (SoOutput *out) const
virtual const char * | getFileFormatName (void) const

## Static Protected Member Functions
static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoNode
static const SoFieldData ** | getFieldDataPtr (void)
static void | setNextActionMethodIndex (int index)
static int | getNextActionMethodIndex (void)
static void | incNextActionMethodIndex (void)
static void | setCompatibilityTypes (const SoType &nodetype, const uint32_t bitmask)
Static Protected Member Functions inherited from SoBase
static uint32_t | getCurrentWriteCounter (void)
static void | staticDataLock (void)
static void | staticDataUnlock (void)

## Protected Attributes
SoChildList * | children
Protected Attributes inherited from SoNode
uint32_t | uniqueId
Protected Attributes inherited from SoFieldContainer
SbBool | isBuiltIn

## Additional Inherited Members
Public Types inherited from SoNode
enum | NodeType { INVENTOR = 0x0000, VRML1 = 0x0001, VRML2 = 0x0002, INVENTOR_1 = 0x0004, INVENTOR_2_0 = 0x0008, INVENTOR_2_1 = 0x0010, INVENTOR_2_5 = 0x0020, INVENTOR_2_6 = 0x0040, COIN_1_0 = 0x0080, COIN_2_0 = 0x0100, EXTENSION = 0x0200, COIN_2_2 = 0x0400, COIN_2_3 = 0x0800, COIN_2_4 = 0x1000, INVENTOR_5_0 = 0x2000, COIN_2_5 = 0x4000, COIN_3_0 = 0x8000, INVENTOR_6_0 = 0x10000 }
Protected Types inherited from SoBase
enum | BaseFlags { IS_ENGINE = 0x01, IS_GROUP = 0x02 }
Static Protected Attributes inherited from SoNode
static uint32_t | nextUniqueId = 1
static int | nextActionMethodIndex = 0

## Detailed Description

The SoNodeKitListPart class is a container node.

This node is basically just a container node with these differences versus the other group nodes:

1. It is possible to make a list of which node class types are allowed as children.
2. You can freely select which kind of group node behaviour you want this container to have. Default is to act like an SoGroup node, but by using SoNodeKitListPart::setContainerType(), you can change the behaviour to be like a separator, a switch or whatever else you have of node types inheriting SoGroup.

See also
  SoGroup, SoSeparator, SoSwitch

## Constructor & Destructor Documentation

SoNodeKitListPart::SoNodeKitListPart | ( | void |  | ) |

Constructor.

SoNodeKitListPart::~SoNodeKitListPart | ( |  | ) |
| protectedvirtual

Destructor.

## Member Function Documentation

SoType SoNodeKitListPart::getTypeId | ( | void |  | ) | const
| virtual

Returns the type identification of an object derived from a class inheriting SoBase. This is used for run-time type checking and "downward" casting.

Usage example:

void foo(SoNode * node)
{
if (node->getTypeId() == SoFile::getClassTypeId()) {
SoFile * filenode = (SoFile *)node; // safe downward cast, knows the type
}
}

For application programmers wanting to extend the library with new nodes, engines, nodekits, draggers or others: this method needs to be overridden in all subclasses. This is typically done as part of setting up the full type system for extension classes, which is usually accomplished by using the pre-defined macros available through for instance Inventor/nodes/SoSubNode.h (SO_NODE_INIT_CLASS and SO_NODE_CONSTRUCTOR for node classes), Inventor/engines/SoSubEngine.h (for engine classes) and so on.

For more information on writing Coin extensions, see the class documentation of the toplevel superclasses for the various class groups.

Implements SoBase.

const SoFieldData * SoNodeKitListPart::getFieldData | ( | void |  | ) | const
| protectedvirtual

Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns `NULL`.

Reimplemented from SoFieldContainer.

void SoNodeKitListPart::initClass | ( | void |  | ) |
| static

Does initialization common for all objects of the SoNodeKitListPart class. This includes setting up the type system, among other things.

SoType SoNodeKitListPart::getContainerType | ( | void |  | ) | const

Return type id for the list container. Default is SoGroup.

void SoNodeKitListPart::setContainerType | ( | SoType | newContainerType | ) |

Change the behaviour of this container node. newContainerType must be derived from SoGroup.

const SoTypeList & SoNodeKitListPart::getChildTypes | ( | void |  | ) | const

Return a list of all types which are allowed as children of this node. Default is to allow all nodetypes.

void SoNodeKitListPart::addChildType | ( | SoType | typeToAdd | ) |

Add one more node class type which should be allowed to be used in the node list.

Note: the default single SoNode type in the list will be removed upon the first call to this method.

SbBool SoNodeKitListPart::isTypePermitted | ( | SoType | typeToCheck | ) | const

Return `TRUE` if nodes of the typeToCheck class type can be added to the list.

SbBool SoNodeKitListPart::isChildPermitted | ( | const SoNode * | child | ) | const

Return `TRUE` if child has a class type which is permitted to be in the list.

void SoNodeKitListPart::containerSet | ( | const char * | fieldDataString | ) |

Calls set() on the container node with fieldDataString.

void SoNodeKitListPart::lockTypes | ( | void |  | ) |

Lock type list so no more node class types can be added by using addChildType(), and locks container type so it no longer can be changed by setContainerType().

SbBool SoNodeKitListPart::isTypeLocked | ( | void |  | ) | const

Returns `TRUE` if the list of allowable node types and the container type have both been locked.

void SoNodeKitListPart::addChild | ( | SoNode * | child | ) |

Adds child to the internal list of children, if it is of a type permitted to be added.

void SoNodeKitListPart::insertChild | ( | SoNode * | child,
|  | int | childIndex
| ) |  |

Inserts child in the internal list of children at position `childIndex`, if it is of a type permitted to be added.

SoNode * SoNodeKitListPart::getChild | ( | int | index | ) | const

Return child node at position index.

int SoNodeKitListPart::findChild | ( | SoNode * | child | ) | const

Return position index of child in list of children.

int SoNodeKitListPart::getNumChildren | ( | void |  | ) | const

Return number of children.

void SoNodeKitListPart::removeChild | ( | int | index | ) |

Remove node at childindex in our list of children.

Please note that this method is not virtual in the original SGI Inventor API.

void SoNodeKitListPart::removeChild | ( | SoNode * | child | ) |

Remove child from the set of children managed by this group node. Will decrease the reference count of child by 1.

This is a convenience method. It will simply call findChild() with child as argument, and then call removeChild(int) if the child is found.

Please note that this method is not virtual in the original SGI Inventor API.

void SoNodeKitListPart::replaceChild | ( | int | index,
|  | SoNode * | newChild
| ) |  |

Replace child at index with newChild, if newChild is of a permitted type.

void SoNodeKitListPart::replaceChild | ( | SoNode * | oldChild,
|  | SoNode * | newChild
| ) |  |

Replace oldChild with newChild, if newChild is of a permitted type.

SbBool SoNodeKitListPart::affectsState | ( | void |  | ) | const
| virtual

Returns `TRUE` if the node could have any effect on the state during traversal.

If it returns `FALSE`, no data in the traversal-state will change from the pre-traversal state to the post-traversal state. The SoSeparator node will for instance return `FALSE`, as it pushes and pops the state before and after traversal of its children. All SoShape nodes will also return `FALSE`, as just pushing out geometry data to the rendering engine won't affect the actual rendering state.

The default method returns `TRUE`, on a "better safe than sorry" philosophy.

Reimplemented from SoNode.

void SoNodeKitListPart::doAction | ( | SoAction * | action | ) |
| virtual

This just "forwards" the call to the same method at the container node.

Reimplemented from SoNode.

void SoNodeKitListPart::callback | ( | SoCallbackAction * | action | ) |
| virtual

This just "forwards" the call to the same method at the container node.

Reimplemented from SoNode.

void SoNodeKitListPart::GLRender | ( | SoGLRenderAction * | action | ) |
| virtual

This just "forwards" the call to the same method at the container node.

Reimplemented from SoNode.

void SoNodeKitListPart::getBoundingBox | ( | SoGetBoundingBoxAction * | action | ) |
| virtual

This just "forwards" the call to the same method at the container node.

Reimplemented from SoNode.

void SoNodeKitListPart::getMatrix | ( | SoGetMatrixAction * | action | ) |
| virtual

This just "forwards" the call to the same method at the container node.

Reimplemented from SoNode.

void SoNodeKitListPart::handleEvent | ( | SoHandleEventAction * | action | ) |
| virtual

This just "forwards" the call to the same method at the container node.

Reimplemented from SoNode.

void SoNodeKitListPart::pick | ( | SoPickAction * | action | ) |
| virtual

This just "forwards" the call to the same method at the container node.

Reimplemented from SoNode.

void SoNodeKitListPart::search | ( | SoSearchAction * | action | ) |
| virtual

This just "forwards" the call to the same method at the container node.

Reimplemented from SoNode.

void SoNodeKitListPart::getPrimitiveCount | ( | SoGetPrimitiveCountAction * | action | ) |
| virtual

This just "forwards" the call to the same method at the container node.

Reimplemented from SoNode.

SoChildList * SoNodeKitListPart::getChildren | ( | void |  | ) | const
| virtual

This just "forwards" the call to the same method at the container node.

Reimplemented from SoNode.

SoGroup * SoNodeKitListPart::getContainerNode | ( | void |  | ) |
| protected

Return the SoGroup container which is the parent of all the children which has been added.

SbBool SoNodeKitListPart::readInstance | ( | SoInput * | in,
|  | unsigned short | flags
| ) |  |
| protectedvirtual

This method is mainly intended for internal use during file import operations.

It reads a definition of an instance from the input stream in. The input stream state points to the start of a serialized / persistant representation of an instance of this class type.

`TRUE` or `FALSE` is returned, depending on if the instantiation and configuration of the new object of this class type went ok or not. The import process should be robust and handle corrupted input streams by returning `FALSE`.

flags is used internally during binary import when reading user extension nodes, group nodes or engines.

Reimplemented from SoNode.

void SoNodeKitListPart::copyContents | ( | const SoFieldContainer * | from,
|  | SbBool | copyconnections
| ) |  |
| protectedvirtual

Makes a deep copy of all data of from into this instance, except external scenegraph references if copyconnections is `FALSE`.

This is the protected method that should be overridden by extension node / engine / dragger / whatever subclasses which needs to account for internal data that are not handled automatically.

For copying nodes from application code, you should not invoke this function directly, but rather call the SoNode::copy() function:

SoNode * mynewnode = templatenode->copy();

The same also goes for engines.

Make sure that when you override the copyContents() method in your extension class that you also make it call upwards to it's parent superclass in the inheritance hierarchy, as copyContents() in for instance SoNode and SoFieldContainer does important work. It should go something like this:

void
MyCoinExtensionNode::copyContents(const SoFieldContainer * from,
SbBool copyconnections)
{
// let parent superclasses do their thing (copy fields, copy
// instance name, etc etc)
SoNode::copyContents(from, copyconnections);
// [..then copy internal data..]
}

Reimplemented from SoNode.

## Member Data Documentation

SoChildList * SoNodeKitListPart::children
| protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

The documentation for this class was generated from the following files:

- SoNodeKitListPart.h
- SoNodeKitListPart.cpp

Copyright © 1998-2010 by Kongsberg Oil & Gas Technologies. All rights reserved.